Bug 123251 - LTC5420 ioctl TIOCGICOUNT not implemented in 32bit for 64bit kernel
LTC5420 ioctl TIOCGICOUNT not implemented in 32bit for 64bit kernel
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel (Show other bugs)
3.0
powerpc Linux
medium Severity medium
: ---
: ---
Assigned To: David Howells
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-05-14 16:24 EDT by Wendy Cheng
Modified: 2007-11-30 17:07 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-02 00:31:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Attach customer's test case. (1.25 KB, text/plain)
2004-05-14 16:27 EDT, Wendy Cheng
no flags Details

  None (edit)
Description Wendy Cheng 2004-05-14 16:24:57 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.0.1)
Gecko/20020830

Description of problem:
IBM reports that the RHEL 3 ppc64 is missing two ioctls - TIOCMIWAIT
and TIOCGICOUNT via IT#29785. The IT ticket also includes their kernel
patch as:

--- ioctl32.c.orig      2003-06-12 12:27:26.000000000 -0500
+++ ioctl32.c   2003-06-19 12:40:16.000000000 -0500
@@ -3709,6 +3709,8 @@
COMPATIBLE_IOCTL(TIOCSSERIAL),
COMPATIBLE_IOCTL(TIOCSERGETLSR),
COMPATIBLE_IOCTL(TIOCSLTC),
+COMPATIBLE_IOCTL(TIOCMIWAIT),
+COMPATIBLE_IOCTL(TIOCGICOUNT),
/* Big F */
COMPATIBLE_IOCTL(FBIOGET_VSCREENINFO),
COMPATIBLE_IOCTL(FBIOPUT_VSCREENINFO),


Version-Release number of selected component (if applicable):
kernel-2.4.21-xx

How reproducible:
Always

Steps to Reproduce:
On IBM p-series machine:

1. Download attached testcase (serialtest.c)
2. compile & run as 32bit executable
3. compile & run as 64bit executable


Actual Results:  When run as a 32 bit executable, testcase fails with:

Java_com_ibm_comm_SerialStatusEventThread_monitorSerialStatusNC:
ioctl(TIOCGICOUNT) error 22!
fd = 3, &oldIcount = 0xfffff018, stateP->rc = -1

When run as a 64bit executable the testcase runs as expected.


Expected Results:  Test should exit, with no errors.

Additional info:

The kernel generates the following message:
kernel: sys32_ioctl(serialtest:12732): Unknown cmd fd(3) cmd(0000545d)
arg (fffff018)

when it is run. This corresponds with the error message in in
linux/arch/ppc64/kernel/ioctl32.c:sys_ioctl32()
The 32bit emulation layer doesn't implement the ioctl we are wanting
to call.
Comment 1 Wendy Cheng 2004-05-14 16:27:13 EDT
Created attachment 100235 [details]
Attach customer's test case.
Comment 3 Ernie Petrides 2004-06-08 00:55:32 EDT
A fix for this problem has just been committed to the RHEL3 U3
patch pool this evening (in kernel version 2.4.21-15.7.EL).
Comment 4 John Flanagan 2004-09-02 00:31:35 EDT
An errata has been issued which should help the problem 
described in this bug report. This report is therefore being 
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files, 
please follow the link below. You may reopen this bug report 
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2004-433.html

Note You need to log in before you can comment on or make changes to this bug.